### MP Fénelon Sainte-Marie --- Informatique
### Chapitre 3 --- Récursivité

###############################################################################
print("---------------- Factorielle itérative ----------------")

def factoI(n):
    r=1
    for i in range(1,n+1):
        r=r*i
    return r
print("la factorielle de ",5," vaut ",factoI(5))

###############################################################################
print("---------------- Factorielle récursive ----------------")

def factoR(n):
    if n<=1: return 1
    else: return n*factoR(n-1)
print("la factorielle de ",5," vaut ",factoI(5))

###############################################################################
print("---------------- EX1 --- Que fait cette méthode ? ----------------")

def r(x,deb,fin,L):
    if deb>fin:
        return "fini"
    t=(deb+fin)//2
    if x==L[t]:
        return t
    if x<L[t]:
        return r(x,deb,t-1,L)
    else:
        return r(x,t+1,fin,L)

L=[2,4,6,7,9,13,26]
resu=r(13,0,6,L)
print(resu)
print(L[5])

###############################################################################
print("---------------- EX2-1 --- Que fait cette méthode ? ----------------")

def ed(L,M): ### version récursive
    if L==[]: return M
    a=L.pop(0)
    if a not in M: M.append(a)
    return ed(L,M)

L=[2,3,2,6,8,9,9,10,9,3,6,7,8,8,9]
print("liste initiale : ",L)
resu=ed(L,[])
print("résultat : ",resu)

###############################################################################
print("---------------- EX2-2 --- Version itérative ----------------")

def ed2(L): ### version itérative
    M=[]
    for i in range(len(L)-1):
        if L[i] not in M: M.append(L[i])
    return M

L=[2,3,2,6,8,9,9,10,9,3,6,7,8,8,9]
print("liste initiale : ",L)
resu=ed2(L)
print("résultat : ",resu)

###############################################################################
print("---------------- EX3 --- Que fait cette méthode ? ----------------")

def pp(L):
    m=L[0]
    for i in range(1,len(L)):
        if L[i]<m:
            m=L[i]
    return m

L=[24,45,2,3,2,6,8,9,9,10,9,3,6,7,8,8,9]
print("la liste :",L)
print("résultat de méthode pp :",pp(L))

###############################################################################
print("---------------- EX3 --- Version récursive ----------------")

def pp2(L):
    if len(L)==1: return L[0]
    if L[0]<L[1]:
        L.pop(1)
    else:
        L.pop(0)
    return pp2(L)

L=[24,45,2,3,2,6,8,9,9,10,9,3,6,7,8,8,9]
print("la liste :",L)
print("résultat de méthode pp2 :",pp2(L))

###############################################################################
print("---------------- EX4 --- PGCD ----------------")

def pgcd(a,b):
    if b==0: return a
    if a<b:
        return pgcd(b,a)
    else:
        return pgcd(a-b,b)

a=2*2*7*11
b=2*5*11
resu=pgcd(a,b)
print(resu)

###############################################################################
print("---------------- EX5 --- Combinaisons ----------------")

def combi(n,k):
    if n==k: return 1
    if k==1: return n
    return combi(n-1,k)+combi(n-1,k-1)

a=5
b=2
resu=combi(a,b)
print(a,"parmi",b," vaut ",resu)

###############################################################################
print("---------------- EX6 --- Algorithme de Héron ----------------")
from math import sqrt

def heronI(x0,A,n):
    r=(x0+(A+x0))/2
    for i in range(1,n):
        r=(r+(A/r))/2
    return r
A=5
for i in range(1,8):
    approx=heronI(1,A,i)
    print("HéronI : pour i=",i," l'erreur est ",approx-sqrt(5))


def heronR(x0,A,n):
    if n==1:
        return x0
    else:
        prec=heronR(x0,A,n-1)
        return (prec+(A/prec))/2
A=5
for i in range(1,8):
    approx=heronR(1,A,i)
    print("HéronR : pour i=",i," l'erreur est ",approx-sqrt(5))

###############################################################################
print("------------ EX7 --- Nombre de chiffres d'un entier ------------")

def NbChiffres(n):
    quotient = n//10
    if quotient == 0:
        return 1
    return 1 + NbChiffres(quotient)

n = 1
print("Le nombre de chiffres de",n,"est",NbChiffres(n))

###############################################################################
print("------------ EX8 --- Suite de Fibonacci ------------")

import time

def FibonacciR(n):
    if n==0 or n==1:
        return 1
    return FibonacciR(n-1) + FibonacciR(n-2)

def FibonacciI(n):
    if n<=1:
        return 1
    au = 1
    u = 1
    for i in range(2,n+1):
        nu = u + au
        au = u
        u = nu
    return nu

n = 5
print("FibonacciR(",n,")=",FibonacciR(n))
print("FibonacciI(",n,")=",FibonacciI(n))
#for i in range(5):
#    print("FibonacciR(",i,")=",FibonacciR(i))
#    print("FibonacciI(",i,")=",FibonacciI(i))

n = 25 # n = 35 donne 7s pour R  et 0s pour I
temps=time.time()
print("FibonacciR(",n,")=",FibonacciR(n))
print("temps pour FibonacciR",time.time()-temps)
temps=time.time()
print("FibonacciI(",n,")=",FibonacciI(n))
print("temps pour FibonacciI",time.time()-temps)

###############################################################################
print("------------ EX9 --- Valeur approchée de Pi ------------")

def wallis(n):
    if n==1:
        return 8/3
    temp = 4*n*n
    return temp * wallis(n-1) / (temp - 1)

for n in range(1,5): # maxi : 50
    print(20*n,wallis(20*n)) # maxi 20*2

###############################################################################
print("------------ EX10 --- Nombres romains ------------")

def romain2decimal(L):
    if L==[]:
        return 0
    lettre = L.pop(0)
    if lettre=='M':
        return 1000+romain2decimal(L)
    if lettre=='D':
        return 500+romain2decimal(L)
    if lettre=='C':
        if L==[]:
            return 100
        if L[0]=='M': # prise en compte de CM = 900
            return romain2decimal(L)-100
        else:
            return 100+romain2decimal(L)
    if lettre=='L':
        return 50+romain2decimal(L)
    if lettre=='X':
        if L==[]:
            return 10
        if L[0]=='L': # prise en compte de XL = 40
            return romain2decimal(L)-10
        if L[0]=='C': # prise en compte de XC = 90
            return romain2decimal(L)-10
        else:
            return romain2decimal(L)+10
        return 10+romain2decimal(L)
    if lettre=='V':
        return 5+romain2decimal(L)
    if lettre=='I':
        if L==[]:
            return 1
        if L[0]=='V': # prise en compte de IV = 4
            return romain2decimal(L)-1
        if L[0]=='X': # prise en compte de IX = 9
            return romain2decimal(L)-1
        else:
            return romain2decimal(L)+1

for nb in ['MMXIV','MMXV','MMXVI','MMXVII','MMXVIII','MMXIX','MMXX']:
    nb2 = list(nb)
    print("En chiffres romains :",nb," en chiffres arabes :",romain2decimal(nb2))

###############################################################################
print("------------ EX10 --- Nombres romains ------------")

import numpy as np
import matplotlib.pyplot as plt
plt.clf()
plt.axis('equal')

def cercle(x,y,r):
    Theta = np.linspace(0,2*np.pi,100)
    X = [x + r * np.cos(theta) for theta in Theta]
    Y = [y + r * np.sin(theta) for theta in Theta]
    plt.plot(X,Y)

def CerclesRec(x,y,r,n):
    cercle(x,y,r)
    if n>1:
        CerclesRec(x, y - 3*r/2, r/2, n-1)
        CerclesRec(x + 3*r/2, y, r/2, n-1)

#CerclesRec(4,5,3,4)

def CercleRec2(x,y,r,n,position):
    cercle(x,y,r)
    if n>1:
        if position=='haut':
            CercleRec2(x, y + 3*r/2, r/2, n-1, 'haut')
            CercleRec2(x - 3*r/2, y, r/2, n-1, 'gauche')
            CercleRec2(x + 3*r/2, y, r/2, n-1, 'droite')

        if position=='gauche':
            CercleRec2(x, y + 3*r/2, r/2, n-1, 'haut')
            CercleRec2(x, y - 3*r/2, r/2, n-1, 'bas')
            CercleRec2(x - 3*r/2, y, r/2, n-1, 'gauche')

        if position=='bas':
            CercleRec2(x, y - 3*r/2, r/2, n-1, 'bas')
            CercleRec2(x - 3*r/2, y, r/2, n-1, 'gauche')
            CercleRec2(x + 3*r/2, y, r/2, n-1, 'droite')

        if position=='droite':
            CercleRec2(x, y + 3*r/2, r/2, n-1, 'haut')
            CercleRec2(x, y - 3*r/2, r/2, n-1, 'bas')
            CercleRec2(x + 3*r/2, y, r/2, n-1, 'droite')

def Cercles(x,y,r,n):
    CercleRec2(x,y,r,n,'haut')
    CercleRec2(x,y,r,n,'bas')
    CercleRec2(x,y,r,n,'gauche')
    CercleRec2(x,y,r,n,'droite')

Cercles(4,3,2,5)